﻿using System;
using System.Windows;

namespace Adapter
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ClickMeButton_Click(object sender, RoutedEventArgs e)
        {
            Person newPerson = new Person();

            // Input
            newPerson.FirstName = FirstNameInput.Text;
            newPerson.LastName = LastNameInput.Text;
            
            // Adapter Pattern
            // StartDate expects a DateTime value; StartDateInput.Text
            // is a string.  The DateTime.Parse method allows us
            // to plug a string into a DateTime field.
            newPerson.StartDate = DateTime.Parse(StartDateInput.Text);

            // Adapter Pattern
            // The Int32.Parse method allows us to plug a string
            // into an integer field.
            newPerson.Rating = Int32.Parse(RatingInput.Text);


            // Ouput
            FirstNameOutput.Text = newPerson.FirstName;
            LastNameOutput.Text = newPerson.LastName;

            // Adapter Pattern
            // The ToString() method allows us to display non-text
            // values to the user.
            StartDateOutput.Text = newPerson.StartDate.ToString("MM/dd/yyyy");
            RatingOutput.Text = newPerson.Rating.ToString();

            // Side Note: When using data binding, the conversions between
            // objects of various types and strings for display all happens
            // automatically (for the most part).
        }

    }

    public class Person
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public DateTime StartDate { get; set; }
        public int Rating { get; set; }
    }
}
