﻿using System;
using System.Windows;

namespace ChainOfResponsibility
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ClickMeButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Method1();
            }
            // Chain of Responsibility Pattern
            // The catch block inspects the Exception and if it
            // matches the correct type, handles it.  Otherwise
            // it pass the Exception to the next member in the chain --
            // in this case, it falls off the chain because there
            // are no other exception handlers (note: you can fix this
            // by creating a default exception handler for the application.
            catch (ArgumentException)
            {
                TextBlock1.Text = "Caught ArgumentException in Click Event";
            }
        }

        private void Method1()
        {
            try
            {
                Method2();
            }
            // Chain of Responsibility Pattern
            // The catch block inspects the Exception and if it
            // matches the correct type, handles it.  Otherwise
            // it pass the Exception to the next member in the chain --
            // in this case, the calling method.
            catch (NullReferenceException)
            {
                TextBlock1.Text = "Caught NullReferenceException in Method 1";
            }
        }

        private void Method2()
        {
            try
            {
                switch (ExceptionBox.Text)
                {
                    case "AccessViolationException":
                        throw new AccessViolationException();
                    case "NullReferenceException":
                        throw new NullReferenceException();
                    case "ArgumentException":
                        throw new ArgumentException();
                    case "Exception":
                        throw new Exception();
                }
            }
            // Chain of Responsibility Pattern
            // The catch block inspects the Exception and if it
            // matches the correct type, handles it.  Otherwise
            // it pass the Exception to the next member in the chain --
            // in this case, the calling method.
            catch (AccessViolationException)
            {
                TextBlock1.Text = "Caught AccessViolationException in Method 2";
            }
        }
    }
}
