﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Documents;

namespace Iterator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ClickMeButton_Click(object sender, RoutedEventArgs e)
        {
            List<Person> people = People.GetPeople();

            // Iterator Pattern
            // List<T> implements IEnumerable<T> which has an
            // Enumerator (Iterator).  The Enumerator has a
            // MoveNext method to move to the next item in the
            // collection and a Current property for the current
            // item.
            var enumerator = people.GetEnumerator();
            while (enumerator.MoveNext())
            {
                PersonListBox.Items.Add(enumerator.Current.ToString());
            }

            // All of this is made transparent with the
            // "foreach" construct
            //foreach (var p in people)
            //{
            //    PersonListBox.Items.Add(p.ToString());
            //}
        }
    }
}
