﻿using System.Windows;

namespace Observer
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            // Observer Pattern
            // Assigning Event Handlers sets these methods
            // up as Observers that are notified when
            // the Click event fires.
            ClickMeButton.Click += Observer1;
            ClickMeButton.Click += Observer2;
            ClickMeButton.Click += Observer3;
        }

        // Observer 1 response to notification
        void Observer1(object sender, RoutedEventArgs e)
        {
            TextBlock1.Text = "Hello from Oberserver 1";
        }

        // Observer 2 response to notification
        void Observer2(object sender, RoutedEventArgs e)
        {
            TextBlock2.Text = "Hello from Oberserver 2";
        }

        // Observer 3 reponse to notification
        void Observer3(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Hello from Observer 3");
        }
    }
}
